/*****************************************************************************
 *
 * External script for sidki's Proxomitron config
 *
 * This is the full version, used in "light config mode" and above.
 *
 * Last edited: 2005-10-18
 *
 *****************************************************************************/

// Parse the whole shebang only if not already done so (XMLHttpRequest/AJAX).
var prxDoneTop;
prxDoneTop = (typeof prxDoneTop == "undefined") ? 0 : prxDoneTop + 1;
if (!prxDoneTop) {

  /******************************* PAGE START ********************************/

  /* ====================================
     Page Load Timer Part I. - hpguru
     ==================================== */

  var prxLdTimer;
  if (prxLdTimer) {
    var prxLdStop, prxLdStart = new Date();
  }

  /* ====================================
     Set some flags.
     ==================================== */

  // Current config mode, set by Proxomitron filters:
  // 1 -> minimal, 2 -> light, 3 -> standard, 4 -> advanced, 5 -> debug.
  var prxCfgLevel;

  // This flag indicates where we currently are in our script. Four stages:
  // 0 -> Beginning.
  // 1 -> End of page.
  // 2 -> Onload event has fired.
  // 3 -> Tiny delay, as IE may run the page's onload function after our one.
  var prxLoaded = 0;

  // Declare the flag that counts replacements of ad scripts with dummy.js.
  var prxDummy = 0;

  // Set the main target element - verified when the page has been loaded.
  var prxElement = document.documentElement;

  // Test for "document.all" support.
  var prxDAll = (document.all) ? 1 : 0;

  // Force offscreen buffering to speed up rendering, default is auto. - hpguru
  window.offscreenBuffering = true;

  // Detect IE, Mozilla, and Opera. - hpguru
  var prxIsIE = (prxDAll && document.getElementById && !window.opera) ? 1 : 0;
  var prxIsMoz = (!prxDAll && document.getElementById && !window.opera) ? 1 : 0;
  var prxIsOp = (window.opera) ? 1 : 0;

  /* ====================================
     Cross-browser event listener registration - Mozilla/IE/Opera/NN4.
     - Scott Andrew LePera
     ==================================== */

  // Temporary handles for the W3C and IE event registration methods.
  window.PrxTMPaddEventListener = window.addEventListener;
  var PrxTMPattachEvent = window.attachEvent;

  function PrxEventAdd(obj, evn, fn, cap) {
    if (!prxIsIE && obj.addEventListener) {
      if (window.PrxTMPaddEventListener) {
        window.addEventListener = window.PrxTMPaddEventListener;
        delete window.PrxTMPaddEventListener;
      }
      cap = (cap) ? cap : false;
      obj.addEventListener(evn, fn, cap);
      // alert("addEvent: " + obj + " :: " + evn);
    } else {
      if (obj.attachEvent) {
        if (PrxTMPattachEvent) {
          window.attachEvent = PrxTMPattachEvent;
          PrxTMPattachEvent = "";
        }
        obj.attachEvent("on" + evn, fn);
        // alert("attachEvent: " + obj + " :: " + evn);
      } else {
        obj["on" + evn] = fn;
        // alert("addNN4: " + obj + " :: " + evn);
      }
    }
  }

  /* ====================================
     Cross-browser event listener unregistration - Mozilla/IE/Opera.
     - Scott Andrew LePera
     ==================================== */

  function PrxEventRemove(obj, evn, fn, cap) {
    if (obj.removeEventListener) {
      cap = (cap) ? cap : false;
      obj.removeEventListener(evn, fn, cap);
      // alert("removeEvent: " + obj + " :: " + evn);
    } else {
      if (obj.detachEvent) {
        obj.detachEvent("on" + evn, fn);
        // alert("detachEvent: " + obj + " :: " + evn);
      } else {
        // alert("Handler could not be removed: " + obj + " :: " + evType);
      }
    }
  }

  /* ====================================
     Loops until the bottom of the page is accessible via DOM, called by other
     functions. - JD, sidki
     ==================================== */

  function PrxLoop(func) {
    var countX = 0;

    function LoopMe() {
      if (countX++ < 200) {
        if (document.getElementById("proxDOM")) {
          func();
        } else {
          PrxRLsetTimeout(LoopMe, 300);
        }
      }
    }
    LoopMe();
  }

  /* ====================================
     Returns the domain portion of the given path. - Paul Rupe, sidki
     ==================================== */

  function PrxGetDomain(url) {
    var b = url.indexOf("/");
    if (b != -1) {
      url = url.substr(0, b);
    }
    b = url.indexOf("@");
    if (b != -1) {
      url = url.substr(b + 1);
    }
    b = url.indexOf(":");
    if (b != -1) {
      url = url.substr(0, b);
    }
    url = (url.indexOf(".") != -1) ?
      url.match(/^(|.+?\.)([^.]+\.((com|net|edu|gov|org|mil|info|biz|..)\...|[0-9.]+|[^.]+))$/i)[2] :
      null;
    return url;
  }

  /* ====================================
     The object that deals with targets.
     ==================================== */

  var prxTgO = {

    // Works its way up to the top window later.
    tgTop : window.self,

    // Returns 1 if the given target refers to an existing frame or window,
    // 0 otherwise. - Paul Rupe
    tgCheck : function(t) {
      if (
        // These names are ok.
        t == "_top" ||
        t == "_parent" ||
        t == "_self" ||
        t == "_content" ||
        t == "_main" ||
        t == "_search" ||

        // Names starting with prx_ (e.g. bookmarklet windows) are ok.
        t.indexOf("prx_") == 0 ||

        // If the target matches an existing frame, ok.
        (this.tgTop.prxTgO.tgNam && this.tgTop.prxTgO.tgNam.indexOf("," + t + ",") != -1)) {

        return 1;
      }
      // Otherwise, no soup for you.
      return 0;
    },

    // Get Window Names Part I.  If this window has a name, append it to the
    // "Frame Names" variable. - Mike/z12
    tgAddName : function() {
      var t = window.self.name;
      if (t) {
        if (typeof this.tgTop.prxTgO.tgNam == "undefined") {
          this.tgTop.prxTgO.tgNam = "," + t + ",";
        } else {
          if (this.tgTop.prxTgO.tgNam.indexOf("," + t + ",") == -1) {
            this.tgTop.prxTgO.tgNam += t + ",";
          }
        }
      }
    },

    // Initialize the target check.  This function is called after the onload
    // event has fired.
    tgInit : function() {
      var countX = 0;

      // Get the name of this window.  IE denies access to the "prxTgO.tgTop",
      // if "document.domain" has been changed after the variable was set.  So
      // check again.
        try {
          prxTgO.tgTop.name;
        } catch(er) {
          this.tgTop = window.self;
        }
        this.tgAddName();

      // Loop until the top window has loaded, so that all child frames have
      // seen above test.  Once done, check the link targets, unless this task
      // is disabled.
      function LoopMe() {
        if (prxTgO.tgTop.prxLoaded > 1 || prxTgO.tgTop == window.self) {
          if (prxTgFrame || prxTgLink) {

            // Debug.
            /*if (prxTgO.tgTop.prxTgO.tgNam) {
              var l = "prxLoaded top/self : " + prxTgO.tgTop.prxLoaded + "/" + prxLoaded;
              PrxFooter("loop", countX + ' -- ' + prxTgO.tgTop.prxTgO.tgNam + ' -- ' + l);
            }*/

            prxTgO.tgLinks();
            if (prxCfgLevel < 5) {
              delete prxTgO.tgAddName;
              delete prxTgO.tgInit;
            }
          }
          // Get the last frame's load time (Page Load Timer Part IV). - hpguru
          if (prxLdTimer && prxCfgLevel > 3 && countX > 0) {
            prxLdStop = prxTgO.tgTop.prxLdStop  + " | Last Frame: " +
              ((new Date()).getTime() - prxTgO.tgTop.prxLdStart.getTime()) / 1000;
            status = window.defaultStatus = prxLdStop;
          }

        } else {
          if (countX++ < 40) {
            // Most frames just need a tiny delay, so set it to 1 ms for the
            // first pass, and to 300 ms for the next ones.
            var delay = (countX == 1) ? 1 : 300;
            PrxRLsetTimeout(LoopMe, delay);

          } else {
            if (prxCfgLevel > 3) {
              PrxFooter("loop", "frame load timeout");
            }
          }
        }
      }
      LoopMe();
    }

  }

  /* ====================================
     Get Window Names Part II. - Mike/z12
     ==================================== */

  // Detect the top window of this document, and if former isn't the current
  // window, create a container to store the names of all frames.
  try {
    while (prxTgO.tgTop.parent.document.domain && prxTgO.tgTop != prxTgO.tgTop.parent) {
      prxTgO.tgTop = prxTgO.tgTop.parent;
    }
  } catch(er) {
  }

  // Opera fires the top window's onload event before the child frames have
  // loaded.  Adding the children's names with the onload function would be too
  // late, so we do it now.
  if (prxIsOp) {
    prxTgO.tgAddName();
  }

  /* ====================================
     Manipulate link targets Part I. - Paul Rupe, sidki, Mike/z12
     ==================================== */

  var prxTgFrame, prxTgLink;
  if (prxTgFrame || prxTgLink) {

    prxTgO.tgLinks = function() {
      var i, d, f, t, c, s;

      for (i = 0, d = document.links; i < d.length; i++) {
        f = d[i];
        if (f.className.indexOf("Prox") != 0) {
          t = f.target;
          if (t) {
            // Open link targets that refer to non-existing windows in the top
            // window. - Paul Rupe
            if (!this.tgCheck(t)) {

              // Popup window name check. - Mike/z12, sidki
              c = (c = f.onclick) ? c :
                (c = f.firstChild) ? ((c = c.onclick) ? c : 0) : 0;
              if (!c) {
                f.target = "_top";
              } else {
                s = new RegExp("\\W" + t + "\\W", "gim");
                if (c.toString().search(s) == -1) {
                  f.target = "_top";
                }
              }

            }
          } else {
            // Open offsite links within frames in the top window. - sidki
            if (prxTgFrame) {
              c = f.href, s = c.indexOf("://");
              s = (s > -1 && s < 6) ? s + 3 : (c.indexOf("//") == 0) ? 2 : 0;
              if (s && prxTgFrame != PrxGetDomain(c.substr(s))) {
                // alert(prxTgFrame + " : " + c + " : " + PrxGetDomain(c.substr(s)));
                f.target = "_top";
              }
            }
          }
        }
      }
    }
  }

  /* ====================================
     Set some of an object's event handlers to null - Part I. - Paul Rupe
     ==================================== */

  var prxStopEvents;
  if (prxStopEvents) {

    function PrxClearEvent(a) {
      if (!a) {
        return;
      }
      a.onmouseleave = null;
      a.onmouseout = null;
      a.onmousewheel = null;
      a.onbeforeunload = null;
      a.onunload = null;
      a.onbeforeprint = null;
      a.onafterprint = null;
      a.onblur = null;
      a.onfocus = null;
      a.onfocusout = null;
      a.onkeydown = null;
      a.onkeypress = null;
      a.onkeyup = null;
      a.oncontextmenu = null;
      a.ondeactivate = null;
      a.onhelp = null;
      a.onlosecapture = null;
      a.onpropertychange = null;
      a.onresize = null;
      a.onscroll = null;
      a.onselect = null;
      a.onselectstart = null;
    }
  }

  /* ====================================
     Create Popup Blocked Notification. - Michael Brschgens, JD
     ==================================== */

  var prxPopNotify, prxCfgDir;
  if (prxPopNotify) {

    // The main notification function, called by the Anti-Popup Code.
    function PrxPopURL(address) {

      // Declare the code that is appended on request.
      function AddMe() {
        var s, f = "http:/" + prxCfgDir + "pop-up.wav";

        // Declare different sound code, depending on the browser.
        if (prxIsIE) {
          s = document.createElement("bgsound");
          s.setAttribute("src", f);
        } else {
          if (prxIsMoz) {
            s = document.createElement("embed");
            s.setAttribute("src", f);
            s.setAttribute("hidden", "true");
          } else {
            if (prxIsOp) {
              s = document.createElement("iframe");
              s.setAttribute("src", "http:/" + prxCfgDir + "pop-operasound.html?" + f);
              s.setAttribute("width", "0");
              s.setAttribute("height", "0");
              s.setAttribute("style", "border:none");
            }
          }
        }

        // Define the image links.
        var p = document.createElement("img");
        p.setAttribute("src", "http:/" + prxCfgDir + "pop-info.gif");
        p.setAttribute("width", "17");
        p.setAttribute("height", "17");
        p.setAttribute("border", "0");
        p.setAttribute("title", "PopUp blocked: " + address);

        var l = document.createElement("a");
        l.setAttribute("href", address);
        l.setAttribute("target", "_top");
        l.appendChild(p);

        // Append the links to the page.
        document.getElementById("proxDOM").appendChild(l);
        document.getElementById("proxDOM").appendChild(s);
      }

      // Loop until the page is ready for appending.
      PrxLoop(AddMe);
    }

  }

  /* ====================================
     Anti-Popup Code Part I. - Scott R. Lemmon
     ==================================== */

  var prxPopup;
  if (prxPopup) {
    var prxPopClick = new Date(0);
    if (prxIsMoz) {
      Window.prototype.PrxRLopen = Window.prototype.open;
    } else {
      eval("var PrxRLopen = window.open");
    }

    // To reroute showModalDialog/showModelessDialog, the second parameter MUST
    // be tested/converted to string if need be since dialogs can also accept
    // objects, whereas "open" only accepts strings as second parameter.
    // A further problem can arise in the third parameter.  The dialog calls
    // have a slightly different format.  Size for instance is passed
    // differently and uses a semicolon instead of an equal sign. - TEggHead
    function PrxNWopen(url, enam, atr) {

      // Make sure the second param is a string. - TEggHead
      var nam = (typeof enam != "string") ? (enam) ? "Dialog" :
        (atr || !prxTgLink) ? "Blank" : "_top" : enam;

      // Allow windows referring to trusted target names - Paul Rupe
      if (enam == nam && prxTgO.tgCheck(nam)) {
        return (PrxRLopen(url, nam, atr));
      }

      // If the page has already loaded and the mouse was clicked within 2
      // seconds, then allow the window.
      var cdt = new Date();
      cdt.setTime(cdt.getTime() - prxPopClick.getTime());
      if (prxPopup == 2 || prxLoaded > 1 && cdt.getSeconds() < 2) {
        if (atr) {
          var query = (url.match(/^(about|keyword):|\?/gi)) ? "" :
            "?prx-keyword=.i_popup_b:11.";
          return (PrxRLopen(url + query, nam, PrxPopAtrSet(atr)));
        } else {
          return (PrxRLopen(url, nam));
        }
      }

      // Grab the PopUp URL for notification function.
      if (prxPopNotify) {
        PrxPopURL(url);
      }
      return true;
    }

    var prxPopAtr;

    function PrxPopAtrSet(atr) {
      if (!prxPopAtr) {
        return (atr);
      }
      var yatr = (prxPopAtr == 2) ? 1 : 0;
      var xatr = "location=1,status=1,scrollbars=1,resizable=1";
      xatr += ",left=" + screen.width * .01 + ",top=" + screen.height * .12;
      xatr += "toolbar=" + yatr + ",menubar=" + yatr;
      if (atr) {
        var hm;
        hm = atr.match(/height(=|:)([0-9]+)/i);
        if (hm) {
          xatr += ",height=" + hm[2];
        } else {
          xatr += ",height=480";
        }
        hm = atr.match(/width(=|:)([0-9]+)/i);
        if (hm) {
          xatr += ",width=" + hm[2];
        } else {
          xatr += ",width=640";
        }
      } else {
        xatr += ",height=480,width=640";
      }
      return (xatr);
    }

    window.open = PrxNWopen;

    // IE Specific Methods. - Homeric
    window.showModalDialog = PrxNWopen;
    window.showModelessDialog = PrxNWopen;
  }

  /* ====================================
     Intercept "window.resizeTo" and "window.moveTo".  Block fullscreen
     resizing, but allow the rest.  Note that Mozilla/Nescape windows can also
     be resized with "outerWidth=this; outerHeight=that".  This gets blocked
     the hard way in the "JSProperties" list. - sidki
     ==================================== */

  var prxCatchResize;
  if (prxCatchResize) {
    if (prxIsMoz) {
      Window.prototype.PrxRLresizeTo = Window.prototype.resizeTo;
      Window.prototype.PrxRLmoveTo = Window.prototype.moveTo;
    } else {
      eval("var PrxRLresizeTo = window.resizeTo");
      eval("var PrxRLmoveTo = window.moveTo");
    }

    function PrxNWresizeTo(wide, high) {
      if (prxCatchResize == 2 || isNaN(wide) ||
        wide >= screen.availWidth || high >= screen.availHeight) {

        var s = (wide) ? wide + " x " + high : "proprietary method";
        PrxFooter("resizeTo blocked", s);
        return true;
      } else {
        PrxFooter("resizeTo allowed", wide + "x" + high);
        return (PrxRLresizeTo(wide, high));
      }
    }
    function PrxNWmoveTo(x, y) {
      if (prxCatchResize == 2 || x <= 1 || x >= screen.availWidth || y <= 1 || y >= screen.availHeight) {
        PrxFooter("moveTo blocked", x + "x" + y);
        return true;
      } else {
        PrxFooter("moveTo allowed", x + "x" + y);
        return (PrxRLmoveTo(x, y));
      }
    }

    window.resizeTo = PrxNWresizeTo;
    window.moveTo = PrxNWmoveTo;
    if (prxIsMoz && prxCatchResize == 2) {
      window.sizeToContent = PrxNWresizeTo;
    }
  }

  /* ====================================
     Strip Proxomitron URL commands from the "hostname" and "href" properties.
     Set "protocol" to "https:", if the URL command was "https..".  Since the
     "location" object cannot be manipulated in IE without leaving the page,
     we need to attach two new properties and rename the original strings
     with a webfilter. - sidki
     ==================================== */

  function PrxFixLoc() {
    var a = location, b = a.hostname, c = b.indexOf(".."), d = a.href, e = d.indexOf("..");
    a.PRXprotocol = (b.indexOf("https..") != -1) ? "https:" : a.protocol;
    a.PRXhostname = (c != -1)? b.substr(c + 2) : b;
    a.PRXhref = (c != -1 && e != -1)? a.PRXprotocol + "//" + d.substr(e + 2) : d;
  }
  PrxFixLoc()

  /* ====================================
     Define the properties as renamed by the "Block: Sel. JS Properties"
     filters. - sidki
     ==================================== */

  var prxSyncUA;
  if (prxSyncUA) {
    if (navigator.PRXuserAgent) {
      navigator.PRXappVersion = navigator.PRXuserAgent.match(/\d[^)]+\)/).toString();
      navigator.PRXappMinorVersion = navigator.PRXappVersion;
      if (navigator.PRXuserAgent.indexOf("Mozilla/4.0") == 0) {
        navigator.PRXappName = "Microsoft Internet Explorer";
      } else {
        if (navigator.PRXuserAgent.indexOf("Mozilla/") == 0) {
          navigator.PRXappName = "Netscape";
        } else {
          if (navigator.PRXuserAgent.indexOf("Opera/") == 0) {
            navigator.PRXappName = "Opera";
          } else {
            navigator.PRXappName = "";
          }
        }
      }
    }
    navigator.PRXcpuClass = "alpha";
    navigator.PRXuserLanguage = "en";
    navigator.PRXbrowserLanguage = "en";
    navigator.PRXsystemLanguage = "en";
    navigator.PRXjavaEnabled = true;
    navigator.PRXcookieEnabled = true;
  }

  /* ====================================
     Block randomizers.  Return a constant for calls to the Math.random()
     method. - sidki, Mike/z12
     ==================================== */

  var prxCatchRandom;
  if (prxCatchRandom) {
    Math.PrxRLrandom = Math.random;
    Math.PrxNWrandom = function() {
      if (--prxCatchRandom > 0) {
        return 0.99999999999999;
      }
    }
    Math.random = Math.PrxNWrandom;
  }

  /* ====================================
     Block various Methods. - Paul Rupe, sidki
     ==================================== */

  // Called by Proxomitron instead of the real names.
  if (prxIsMoz) {
    Window.prototype.PrxRLsetTimeout = Window.prototype.setTimeout;
    Window.prototype.PrxRLsetInterval = Window.prototype.setInterval;
  } else {
    eval("var PrxRLsetTimeout = window.setTimeout");
    eval("var PrxRLsetInterval = window.setInterval");
  }

  // Dummy function.
  function PrxDummyZero(string) {
  }

  var prxStopMethods;
  if (prxStopMethods) {

    // Override some window manipulation APIs (which never should have existed
    // in first place).
    window.focus = PrxDummyZero;
    window.resizeBy = PrxDummyZero;
    window.moveBy = PrxDummyZero;

    function clipboardData() {
      return true;
    }

    function createPopup() {
      return true;
    }

    // Override these window properties as well.
    function status() {
      return true;
    }
  }

  /* ====================================
     Provide definitions for properties or common functions that get renamed or
     filtered out and cause subsequent errors. - Paul Rupe, sidki
     ==================================== */

  var prxVoid, MSIE, expires = new Date(0);
  document.PRXcookie = "ProxMessage=GoFigureItOut";

  // Block ad blocker detection in http://spywareguide.com/abd.js and possibly
  // elsewhere.
  var google_random = 1;

  // Would at least break things at FOXNews if undefined.
  function OAS_AD() {
    return true;
  }

  /* ====================================
     Print messages dynamically to the footer, called by other functions.
     - sidki
     ==================================== */

  function PrxFooter(title, msg) {
    if (prxCfgLevel > 2) {
      msg = (typeof msg == "string") ? msg.replace(/\n/g, "//") : msg;

      function FWrite() {
        var tag = document.createElement("span");
        tag.setAttribute("class", "Prox");
        tag.style.display = "inline";
        var text = document.createTextNode(" \u2022\u00A0" + title + ": " + msg);
        tag.appendChild(text);
        document.getElementById("proxDOM").appendChild(tag);
        return false;
      }

      PrxLoop(FWrite);
    }
  }

  /* ====================================
     Show error messages in the footer.  IE and Mozilla only for now, Opera
     ignores it - sidki
     ==================================== */

  var prxCatchErrors;
  if (prxCatchErrors) {

    function PrxNWonerror(msg) {
      if (--prxCatchErrors >= 0) {
        PrxFooter("JS Error", msg);
      }
      return false;
    }
    window.onerror = PrxNWonerror;
  }

  /* ====================================
     Alerts to Footer. - sidki
     ==================================== */

  var prxCatchAlerts, prxCatchBoxes;
  if (prxCatchAlerts || prxCatchBoxes) {
    if (prxIsMoz) {
      Window.prototype.PrxRLalert = Window.prototype.alert;
    } else {
      eval("var PrxRLalert = window.alert");
    }
  }

  if (prxCatchAlerts) {

    function PrxNWalert(msg) {
      PrxFooter("JS Alert", msg);
    }
    window.alert = PrxNWalert;
  }

  /* ====================================
     Restrict Message Boxes. - Paul Rupe
     ==================================== */

  if (prxCatchBoxes) {
    if (prxIsMoz) {
      Window.prototype.PrxRLprompt = Window.prototype.prompt;
      Window.prototype.PrxRLconfirm = Window.prototype.confirm;
    } else {
      eval("var PrxRLprompt = window.prompt");
      eval("var PrxRLconfirm = window.confirm");
    }

    // Returns true if alert/confirm/prompt have not been called a bunch of
    // times already, false if they have not.  Used to stop runaway scripts
    // abusing these popup functions.
    function PrxCatchBoxCheck() {
      if (prxLoaded < 2 || prxCatchBoxes == 999) {
        return false;
      }
      if (--prxCatchBoxes >= 0) {
        return true;
      }
      if (PrxRLconfirm("*** PROXOMITRON ALERT ***\nThis script is too busy for its own good.  Kill it?")) {
        prxCatchBoxes = 999;
        return false;
      } else {
        return true;
      }
    }

    function PrxNWconfirm(m) {
      if (!PrxCatchBoxCheck()) {
        return null;
      }
      return PrxRLconfirm(m);
    }
    window.confirm = PrxNWconfirm;

    function PrxNWprompt(m, d) {
      if (!PrxCatchBoxCheck()) {
        return null;
      }
      if (!d) {
        d = "";
      }
      return PrxRLprompt(m, d);
    }
    window.prompt = PrxNWprompt;

    if (!prxCatchAlerts) {
      function PrxNW2alert(m) {
        if (!PrxCatchBoxCheck()) {
          return null;
        }
        return PrxRLalert(m);
      }
      window.alert = PrxNW2alert;
    }
  }

  /* ====================================
     Intercept calls to *.location.replace() Part I.
     Mozilla ignores it ("replace" is an unreachable). - Paul Rupe, sidki
     ==================================== */

  var prxCatchLoc;
  if (prxCatchLoc) {
    var PrxRLreplace = location.replace;

    function PrxNWreplace(l) {
      if (prxLoaded < 2) {
        prxCatchLocURL = l;
        return false;
      } else {
        window.location.replace = PrxRLreplace;
        window.navigate = PrxRLreplace;
        return location.replace(l);
      }
    }

    window.location.replace = PrxNWreplace;
    window.navigate = PrxNWreplace;
  }

  /* ====================================
     Translate the property into a string for display.  Replace <, >, &, etc.
     with their HTML entities.  Called by other functions - Paul Rupe, sidki
     ==================================== */

  function PrxFuncToString(prop) {
    var c, i, t = "", s = prop.toString();
    for (i = 0; c = s.charAt(i); i++) {
      if (c == "<") {
        t += "&lt;";
      } else {
        if (c == ">") {
          t += "&gt;";
        } else {
          if (c == "&") {
            t += "&amp;";
          } else {
            if (c == "\r") {
              t += "";
            } else {
              if (c == "\n") {
                t += "<br>";
              } else {
                if (c == "\"") {
                  t += "&quot;";
                } else {
                  t += c;
                }
              }
            }
          }
        }
      }
    }
    return t;
  }

  /* ====================================
     Timers to button -- Intercept "setInterval" and "setTimeout" functions
     that are triggered before the page has completely loaded with a start/stop
     button. - sidki
     ==================================== */

  var prxCatchTimers;
  if (prxCatchTimers) {
    var prxTimerO = {
      tiAppend : function(meth, func, time) {

        // If this is the first call, initialize the variables.
        if (!this.tiColl) {
          this.tiColl = "";
          this.tiCount = new Array();
          var rtext = (!prxIsOp) ? ",<br>right-click to run once without delay" : "";
          var otext = "", b = document.getElementById("proxTimer");

          // If the hidden timer button has already been written, then the
          // intercepted timer function was called via the onload event.
          // Show the button.
          if (b) {
            otext = " (onload)";
            b.style.display = "inline";
          }
          this.tiFirst = {

            // On right-click run the first timer function just once and
            // without delay.  Opera ignores that.
            rclick : func,

            over : "<span class=ProxFlyVar>first instance" + otext +
              ": " + meth + " " + time / 1000 + " second(s)" + rtext +
              ":</span><br>" + PrxFuncToString(func)
          }
        }

        var qfunc = (typeof func == "string") ?
          "'unescape(\"" + escape(func) + "\")'" : func;

        // Append the data of the current timer instance to "command-line" var.
        this.tiColl += "prxTimerO.tiRun('" + meth + "', " + qfunc + ", " + time + ");";
      },

      // Trigger a timer with passed params, add the timer ID to an array,
      // so that it can be stopped later.
      tiRun : function(meth, func, time) {
        eval("var t = PrxRL" + meth + "(" + func + ", " + time + ");");
        this.tiCount.push(t);
      },

      // The "onclick" function for the timer button.  Works like a toggle.
      tiClick : function() {
        var i, b = document.getElementById("proxTimer");

        // Case 1:  We've pushed the button before, it displays "stop" now, so
        // that's what we do here.
        if (prxCatchTimers == 1) {
          prxCatchTimers = 0;
          b.setAttribute("value", "timer");
          window.setTimeout = PrxDummyZero;
          window.setInterval = PrxDummyZero;

          // Stop all previously triggered timer IDs.
          while (this.tiCount.length) {
            i = this.tiCount.shift();
            window.clearTimeout(i);
            window.clearInterval(i);
          }

        // Case 0:  Button displays "timer".  We want to start all captured
        // timers with the current click.
        } else {
          prxCatchTimers = 1;
          b.setAttribute("value", " stop ");
          window.setTimeout = PrxRLsetTimeout;
          window.setInterval = PrxRLsetInterval;

          // Run the "command-line" variable that contains all timer requests.
          eval(this.tiColl);
        }
      }

    }

    // Intercept "setTimeout".
    function PrxNWsetTimeout(func, time) {
      var fn = func.toString();
      if (prxLoaded < 3 && fn.indexOf("menu") == -1 && fn.indexOf("Menu") == -1) {
        if ((time > 300 || prxCatchTimers == 3) &&

          // Prototype registration in Mozilla.
          fn.indexOf(".apply") == -1 &&

          // That's how Mozilla internally calls the "scrolldelay" of Marquees.
          fn.indexOf("myTimeOutFunction") != 10) {

          prxTimerO.tiAppend("setTimeout", func, time);
        } else {
          prxCatchTimers = 3;
          PrxRLsetTimeout(func, time);
        }
      } else {
        window.setTimeout = PrxRLsetTimeout;
        setTimeout(func, time);
      }
    }
    window.setTimeout = PrxNWsetTimeout;

    // Intercept "setInterval".
    function PrxNWsetInterval(func, time) {
      var fn = func.toString();
      if (prxLoaded < 3 && fn.indexOf("menu") == -1 && fn.indexOf("Menu") == -1) {
        if (fn.indexOf(".apply") == -1) {
          prxTimerO.tiAppend("setInterval", func, time);
        } else {
          PrxRLsetInterval(func, time);
        }
      } else {
        window.setInterval = PrxRLsetInterval;
        setInterval(func, time);
      }
    }
    window.setInterval = PrxNWsetInterval;

  }

  /* ====================================
     Toggle (show/hide) span tags with specified classname or ID. - sidki
     ==================================== */

  function PrxToggle(nam, atr, tag, tog) {
    var tags = window.document.getElementsByTagName(tag);
    for (var i = 0; i < tags.length; i++) {
      if ((atr == "cl" && nam == tags[i].className.split(" ")[0]) ||
        (atr == "id" && nam == tags[i].id)) {
        if (tags[i].style.display != "inline") {
          tags[i].style.display = "inline";
        } else {
          if (tog) {
            tags[i].style.display = "none";
          }
        }
        if (tags[i].style.visibility == "hidden") {
          tags[i].style.visibility = "visible";
        } else {
          if (tags[i].style.visibility == "visible") {
            tags[i].style.visibility = "hidden";
          }
        }
      }
    }
  }

  /* ====================================
     Clickable flyover  Part I. - Dynamic Drive, sidki, Martin Konicek
     ==================================== */

  // Pop-it menu - By Dynamic Drive.  For full source code and more DHTML
  // scripts, visit http://www.dynamicdrive.com .  This credit MUST stay intact
  // for use.
  var prxFrameset, prxFlyO = {
    flShow : function(which, e, movex) {
      if (!prxFrameset) {

        // Adjustable variables.
        var offX = 0;
        var offY = 10;
        var tdShow = 800;

        if (!e) {
          e = event;
        }
        this.flObject = (prxDAll) ?
          document.all.proxFlyover : document.getElementById("proxFlyover");
        if (this.flObject) {
          this.flObject.innerHTML = which;

          // Find out the mouse position relative to the viewport. - sidki
          var hereX = e.pageX ? e.pageX : prxElement.scrollLeft + e.clientX;
          var hereY = e.pageY ? e.pageY : prxElement.scrollTop + e.clientY;

          // If the mouse is too close to the viewports right or top edge, move the
          // position of the flyover to the left or bottom.
          var pWidth = this.flObject.offsetWidth + offX;
          var pHeight = this.flObject.offsetHeight + offY;
          hereX = (movex && prxElement.clientWidth - e.clientX < pWidth) ?
            hereX - pWidth : hereX + offX;
          hereY = (e.clientY < pHeight) ? hereY + offY : hereY - pHeight;

          // Mozilla's standards-compliant mode needs units, Opera and IE don't
          // care. - sidki
          this.flObject.style.left = hereX + "px";
          this.flObject.style.top = hereY + "px";

          this.flClearHide();
          this.flHide();
          this.flIdShow = PrxRLsetTimeout("prxFlyO.flObject.style.visibility='visible'", tdShow);
        }
      }
    },

    flDHide : function() {
      if (!prxFrameset) {

        // Adjustable variable.
        var tdHide = 800;

        if (this.flIdShow) {
          clearTimeout(this.flIdShow);
        }
        this.flIdShow = PrxRLsetTimeout("prxFlyO.flHide()", tdHide);
      }
    },

    flHide : function() {
      if (this.flObject) {
        this.flObject.style.visibility = "hidden";
      }
    },

    flClearHide : function() {
      if (this.flIdShow) {
        clearTimeout(this.flIdShow);
      }
    },

    flDynHide : function(e) {
      if (prxIsMoz) {

        // Determines if one element in contained in another. - Brainjar.com
        var ct = e.currentTarget, rt = e.relatedTarget;
        if (rt && ct != rt) {
          while (rt.parentNode) {
            if ((rt = rt.parentNode) == ct) {
              return true;
            }
          }
          this.flHide();
        }

      } else {
        if (!this.flObject.contains(e.toElement)) {
          this.flHide();
        }
      }
      return false;
    },

    // Make an anchor with the passed information. - Martin Konicek
    flLink : function(dummy, name, url, prefix) {
      var flContent = (prefix) ? prefix : "";
      flContent += "<a href=" + unescape(url) + ">" + name + "</a>";
      return flContent;
    }

  }

  /******************************** PAGE END *********************************/

  /* ====================================
     The object that deals with buttons.
     ==================================== */

  var prxButtonO = {

    // Creates a button to call a given event handler directly if such a
    // handler is defined.  Rather than disable e.g. window.onload completely,
    // this lets you call it at will in case some page requires it to function.
    // - Paul Rupe
    create : function(objn, propn) {
      var fpropn = objn + ".PrxRL" + propn;
      eval("var prop = " + objn + "." + propn);
      if (prop) {
        eval(fpropn + " = prop");
        var propd = PrxFuncToString(prop.toString().replace(/'/g, "&#39;"));
        document.writeln("<input class=\"ProxButton\" type=\"button\" value=\"" +
          propn + "\" onmouseover=\"prxFlyO.flShow('<div class=ProxFlyCont>" + propd +
          "</div>',event,0)\" onmouseout=\"prxFlyO.flDHide()\" onclick=\"" + fpropn +
          "();\">");
      }
    },

    // Various Events to Button - Paul Rupe
    getEvents : function() {
      this.create("window", "onunload");
      this.create("window", "onbeforeunload");
      this.create("window", "onbeforeprint");
      this.create("window", "onafterprint");
      this.create("window", "onblur");
      this.create("window", "onfocus");
      this.create("window", "onresize");
      this.create("window", "onscroll");
    },

    // "onload" Events to Button - Paul Rupe
    getOnload : function() {
      this.create("window", "onload");

      function clearOnload(a) {
        if (!a) {
          return;
        }
        a.onload = null;
      }

      clearOnload(document);
      clearOnload(document.body);
      clearOnload(window);
    },

    // "onerror" Events to Button - sidki
    getOnerror : function() {
      var er = window.onerror;
      if (er && er.toString().indexOf("function PrxNWonerror") == -1) {
        this.create("window", "onerror");
        window.onerror = (prxCatchErrors) ? PrxNWonerror : null;
      }
    }

  }

  /* ====================================
     The object that deals with internal functions.
     ==================================== */

  var prxIntO = new Object();

  /* ====================================
     Set the main target element depending on rendering mode and browser.
     Needs to be called when the page is already loaded. - sidki
     ==================================== */

  prxIntO.iGetEl = function() {
    prxElement = (
      (!prxIsOp && document.compatMode && document.compatMode == "CSS1Compat")
      || !document.body) ? document.documentElement : document.body;
  }

  /* ====================================
     Declare a function for Proxomitron's own popups here in advance.  Needed
     for pages that block direct access to the "open" method later on. - sidki
     ==================================== */

  function PrxMyPop(w1, w2) {
    var x = (typeof PrxRLopen == "function") ? PrxRLopen : window.open,
    xatr = "location=0,status=0,scrollbars=1,status=0,menubar=0,resizable=1";
    xatr += ",left=" + screen.width * .01 + ",top=" + screen.height * .12;
    return x(w1, "prx_menu", xatr + w2);
  }

  /* ====================================
     Proxomitron Menu  Part I. - sidki
     ==================================== */

  var prxMenu;
  if (prxMenu) {
    var prxMenuO = {
      meStyle : (document.styleSheets) ? 1 : "",

      meWrite : function(layout, script, proxy, spoof, top, up, css, url_e) {

        // Prefetch menu icons.
        var cold = "http:/" + prxCfgDir + "proxm-cold.gif",
        hot = "http:/" + prxCfgDir + "proxm-hot.gif",
        pic = new Array();
        pic[0] = new Image();
        pic[0].src = cold;
        pic[1] = new Image();
        pic[1].src = hot;
        // Set vars for the menu.
        var here = window.location, url = unescape(url_e), path, base;
        if (here.protocol.match(/^(about|keyword):/)) {
          var urlA = url.match(/^([^:]+:\/\/[^\/]+)(\/([^\/?]+\/)*)/);
          path = urlA[0];
          base = urlA[1];
        } else {
          base = (here.protocol + "//" + here.host);
          path = base + here.pathname;
        }
        var hostA = url.match(/:\/\/([^\/]+)/)[1],
        wname = (typeof window.name == "undefined") ? "Something's odd!" :
          (wname = window.name.toString()) ? wname.match(/^(.{1,15}).*/i)[1] :"Dynamic",
        quirk = document.compatMode,
        size = (typeof document.fileSize == "string") ? document.fileSize + " bytes" : "Navigate",
        scripts = document.getElementsByTagName("script").length - 4,
        anc = "\n<div class=\"ProxMCont\"><a class=\"ProxMLink\"",
        targP = (prxMenu == 2) ? " target=_blank" : " target=_top",
        togglestyle = (css && this.meStyle) ? anc + " href=\"javascript:prxMenuO.mlTStyle()\">Toggle Styles (" + css + ") &#8756;</a>" : "",
        shell = (prxIsIE) ? "shell-11.html" : "shell.html",
        viewvars = (prxIsMoz || prxIsOp) ? anc + " href=\"javascript:prxMenuO.mlJSvars()\">JS Variables &#8756;</a>" : "",
        viewscripts = (prxIsMoz && scripts > 0) ? anc + " href=\"javascript:prxMenuO.mlScripts()\">All Scripts &#8756;</a>" : "",
        comm1 = anc + targP + " href=\"" + path + here.search + "?prx-command=",
        comm2 = here.hash + "\">",
        select = anc + " href=\"javascript:var q = &quot;&quot; + (window.getSelection ? window.getSelection() : document.getSelection ? document.getSelection() : document.selection.createRange().text); var s = (window.opera) ? &quot;&quot; : &quot;You didn't select any text.  &quot;; if (!q) q = prompt(s + &quot;Enter a host name or leave empty for current host:&quot;, &quot;&quot;); if (q==&quot;&quot || (q==null && parent.frames.length > 0)) q=&quot;" + hostA + "&quot;; if (q!=null) ",
        check = anc + "><label class=\"ProxMLink\"><input class=\"ProxMLink\" type=checkbox value=",
        rd = anc + "><label class=\"ProxMLink\"><input class=\"ProxMLink\" type=radio name=\"proxMMode\" ";
        layout = (layout) ? check + "\"i_layout:-1\" /><strong>Alter</strong> Layout</label></a></div>" : check + "\"i_layout:1\" /><strong>Keep</strong> Layout</label></a></div>";
        script = (script) ? check + "\"i_script:-1\" /><strong>Allow</strong> Scripts</label></a></div>" : check + "\"i_script:1\" /><strong>Block</strong> Scripts</label></a></div>";
        proxy = (proxy) ? check + "\"i_proxy:-1\" /><strong>No</strong> Proxy</label></a></div>" : check + "\"i_proxy:1\" /><strong>Use</strong> Proxy</label></a></div>";
        spoof = (spoof) ? check + "\"i_spoof:-1\" /><strong>Don't</strong> spoof IP</label></a></div>" : check + "\"i_spoof:1\" /><strong>Spoof</strong> IP</label></a></div>";
        top = (top) ? anc + " target=_top href=\"" + top + "\">Top</a></div>" : "";
        up = (up) ? anc + " target=_top href=\"" + up + "\">Up</a></div>" : "";

        // Set modi for the menu.
        var l1 = "value=\"i_level:1\" />Minimal Mode</label></a></div>",
        l2 = "value=\"i_level:2\" />Light Mode</label></a></div>",
        l3 = "value=\"i_level:3\" />Standard Mode</label></a></div>",
        l4 = "value=\"i_level:4\" />Advanced Mode</label></a></div>",
        l5 = "value=\"i_level:5\" />Debug Mode</label></a></div>",
        levels =
          (prxCfgLevel == 1) ? rd + l5 + rd + l4 + rd + l3 + rd + l2 + rd + "checked " + l1 :
          (prxCfgLevel == 2) ? rd + l5 + rd + l4 + rd + l3 + rd + "checked " + l2 + rd + l1 :
          (prxCfgLevel == 4) ? rd + l5 + rd + "checked " + l4 + rd + l3 + rd + l2 + rd + l1 :
          (prxCfgLevel == 5) ? rd + "checked " + l5 + rd + l4 + rd + l3 + rd + l2 + rd + l1 :
                               rd + l5 + rd + l4 + rd + "checked " + l3 + rd + l2 + rd + l1;

        document.write(
          // Write the icon
          "\n\n<div id=proxMIcon style=visibility:hidden>\n<a" +
          " onmouseover=\"proxIcon.src='" + hot + "';prxMenuO.meShow();\"" +
          " onmouseout=\"proxIcon.src='" + cold + "';prxMenuO.meHide();\"" +
          " onclick=\"this.style.display = 'none';\"" +
          ">\n<img name=proxIcon src=\"" + cold + "\" alt=\"\" />" +
          "\n</a></div>" +

          // Write the menu
          "\n<div id=proxMDiv onmouseover=clearTimeout(prxMenuO.miTimer); onmouseout=prxMenuO.meHide(); style=visibility:hidden>" +
          "\n<table class=\"ProxMTab\"><tbody><tr>" +

          "\n<td class=\"ProxMTdL\">" +
          "\n<div class=\"ProxMSep\">" + wname + "</div>" +
          anc + " href=\"javascript:PrxToggle('Prox','cl','span',1)\" target=\"_self\">Toggle Kills &#8756;</a></div>" +
          togglestyle +
          anc + " href=\"javascript:prxMenuO.mlDparent()\">Toggle DOM Path &#8756;</a></div>" +
          anc + " href=\"javascript:prxMenuO.mlTopo()\">Toggle Topo View &#8756;</a></div>" +
          anc + " href=\"javascript:for(i=0;i<10000;i++){window.clearInterval(i);window.clearTimeout(i)}\">Kill Timers &#8756;</a></div>" +

          "\n<div class=\"ProxMSep\">" + scripts + " Script(s)</div>" +
          viewscripts +
          anc + " href=\"javascript:void(PrxMyPop('" + prxCfgDir + shell + "',',width=663,height='+screen.height*.6))\">JavaScript Shell &#8756;</a></div>" +
          viewvars +
          anc + " href=\"javascript:prxMenuO.mlIDs()\">Classes &amp; IDs &#8756;</a></div>" +
          anc + " href=\"javascript:prxMenuO.mlDynSrc()\">DHTML Source &#8756;</a></div>" +
          anc + " href=\"javascript:function PrxDocProps(){var i,f,g=0,h=document.links;for(i=0;i<h.length;i++){f=h[i];if(f.className.indexOf('Prox')==0)g++};var a='Window name: '+window.name+'\\nLast modified: '+document.lastModified +'\\nNumber of images: '+(document.images.length-1)+'\\nNumber of links: '+(h.length-g)+'\\nNumber of forms: '+(document.forms.length-1)+'\\nNumber of embedded objects: '+document.embeds.length+'\\n';var prxz=prxCatchAlerts?PrxRLalert:alert;prxz(a)};PrxDocProps()\">Doc Properties &#8756;</a></div>" +

          "\n<div class=\"ProxMSep\">Verify</div>" +
          anc + targP + " href=\"http://pgl.yoyo.org/adservers/serverlist.php?hostformat=hosts&amp;showintro=0\">Ad Lists</a></div>" +
          anc + targP + " href=\"http://www.sysinfo.org/bholist.txt\">Bad ClsIDs</a></div>" +
          anc + targP + " href=\"http://www.geocities.com/sidki3003/prox-down.html\">Config Updates</a></div>" +

          "\n<div class=\"ProxMSep\">Translate</div>" +
          anc + targP + " href=\"http://translate.google.com/translate_c?u=" + escape(url) + "\">Google: automatic</a></div>" +
          anc + targP + " href=\"http://babelfish.altavista.com/babelfish/trurl_pagecontent?lp=ru_en&amp;url=" + escape(url) + "\">BabelFish: Russian</a></div>" +
          anc + targP + " href=\"http://babelfish.altavista.com/babelfish/tr?url=" + escape(url) + "\">BabelFish: choose</a></div>" +
          anc + targP + " href=\"http://www.tranexp.com:2000/Translate/index.shtml?type=url&amp;url=" + escape(url) + "\">InterTran: choose</a></div>" +

          "\n</td><td class=\"ProxMTdL\">" +
          "\n<div class=\"ProxMSep\">" + size + "</div>" +
          top +
          up +

          "\n<div class=\"ProxMSep\">" + quirk + "</div>" +
          comm1 + "src.." + comm2 + "src</a></div>" +
          comm1 + "src..bweb.." + comm2 + "src..bweb</a></div>" +
          comm1 + "dbug.." + comm2 + "dbug</a></div>" +
          comm1 + "bweb.." + comm2 + "bweb</a></div>" +
          comm1 + "bypass.." + comm2 + "bypass</a></div>" +

          "\n<div class=\"ProxMSep\">Site</div>" +
          anc + targP + " href=\"http://validator.w3.org/check?uri=" + url + "&amp;ss=1&amp;sp=1&amp;noatt=1&amp;verbose=1\">Validate</a></div>" +
          anc + targP + " href=\"http://uptime.netcraft.com/up/graph/?host=" + hostA + "\">Netcraft</a></div>" +
          anc + targP + " href=\"http://www.google.com/search?q=cache:" + url + "\">Cached</a></div>" +
          anc + targP + " href=\"http://web.archive.org/web/*/" + url + "\">Wayback</a></div>" +
          anc + targP + " href=\"http://www.alexa.com/data/details/main?url=" + url + "\">Alexa</a></div>" +
          anc + " href=\"javascript:(function(){var d=PrxMyPop('',',width=370,height=210').document;d.write('<html><head><title>3000 Italia - Loading...</title></head><body><form name=pform method=POST action=/local.ptron/http://seo.3000.it/lpopularity.php><input name=id type=hidden value=result><input name=url type=hidden value=" + escape(url) + "></form><script>window.setTimeout(&quot;document.pform.submit()&quot;,300);</script></body></html>');d.close();})()\">Popularity &#8756;</a></div>" +
          anc + " href=\"javascript:void(PrxMyPop('http://bugmenot.com/view.php?mode=bookmarklet&amp;url='+escape(&quot;" + hostA + "&quot;),',width=385,height=355'))\">BugMeNot &#8756;</a></div>" +
          //anc + targP + " href=\"" + base + "/robots.txt\">Robots?</a></div>" +

          "\n<div class=\"ProxMSep\">Host or IP</div>" +
          select + "(function(){var d=PrxMyPop('',',width=350,height=350').document;d.write('<html><head><title>All Net Tools - Loading...</title></head><body><form name=pform method=POST action=http://www.all-nettools.com/toolbox?prx-keyword=.s_flag.><input name=smartwhois type=hidden value=' + escape(q) + '><input name=swsubmit type=hidden value=GO%21></form><script>window.setTimeout(&quot;document.pform.submit()&quot;,300);</script></body></html>');d.close();})(); void 0\">SmartWhois &#8756;</a></div>" +
          select + "location=&quot;http://www.samspade.org/t/lookat?a=&quot; + escape(q); void 0\">Whois &#8756;</a></div>" +
          select + "location=&quot;http://www.geobytes.com/iplocator.htm?getlocation&amp;ipaddress=&quot; + escape(q); void 0\">Location &#8756;</a></div>" +
          //anc + " href=\"javascript:var q = &quot;&quot; + (window.getSelection ? window.getSelection() : document.getSelection ? document.getSelection() : document.selection.createRange().text); var s = (window.opera) ? &quot;&quot; : &quot;You didn't select any text.  &quot;; if (!q) q = prompt(s + &quot;Enter a URL or leave empty for current document:&quot;, &quot;&quot;); if (q==&quot;&quot || (q==null && parent.frames.length > 0)) q=&quot;" + url + "&quot;; if (q!=null) location=&quot;http://www.forret.com/projects/analyze/?url=&quot; + escape(q); void 0\">Headers &#8756;</a></div>" +

          "\n</td><td class=\"ProxMTdR\">" +
          "\n<div class=\"ProxMSep\">Allow</div>" +
          "\n<form class=\"ProxMLink\" action=\"\">" +
          check + "\"a_js\" />All JavaScript</label></a></div>" +
          check + "\"a_ads\" />All Ads</label></a></div>" +
          check + "\"a_adban\" />Ad Banners</label></a></div>" +
          check + "\"a_adcomm1.a_adcomm2\" />Ad Comments</label></a></div>" +
          check + "\"a_adcont.a_adtab.a_adform\" />Ad Containers</label></a></div>" +
          check + "\"a_adjs\" />Ad JavaScript</label></a></div>" +
          check + "\"a_track\" />Trackers</label></a></div>" +
          check + "\"a_redir\" />Redirects</label></a></div>" +
          check + "\"a_rdlink.a_jslink\" />Redir & JS Links</label></a></div>" +
          check + "\"a_flash.a_embed\" />Flash & Media</label></a></div>" +
          //check + "\"a_ua\" />User-Agent</label></a></div>" +
          "\n<div class=\"ProxMSep\"></div>" +
          layout +
          script +
          proxy +
          spoof +
          "\n<div class=\"ProxMSep\"></div>" +
          levels +
          "\n<input id=\"proxMBut1\" class=\"ProxMBut\" type=\"button\" value=\"Go\" onClick=\"prxMenuO.mlForm(this.form,'go')\" />" +
          "\n<input id=\"proxMBut2\" class=\"ProxMBut\" type=\"button\" value=\"Session\" onClick=\"prxMenuO.mlForm(this.form,'session')\" />" +
          "\n<input id=\"proxMBut3\" class=\"ProxMBut\" type=\"button\" value=\"List\" onClick=\"prxMenuO.mlForm(this.form,'list')\" />" +
          "\n</form>\n</td>" +

          "</tr></tbody></table></div>"
        );
      },

      // Show the menu
      meShow : function() {
        clearTimeout(this.miTimer);
        if (this.miId.style.visibility == "visible") {
          return;
        }
        var bodyX = (prxIsMoz) ?
          (prxElement.clientWidth - document.body.clientWidth) / 2 :
          document.body.offsetLeft;
        this.miId.style.left =
          ((window.pageXOffset) ? window.pageXOffset : prxElement.scrollLeft) +
          prxElement.clientWidth - this.miX - bodyX - 50 + "px";
        this.miId.style.top =
          ((window.pageYOffset) ? window.pageYOffset : prxElement.scrollTop) +
          prxElement.clientHeight - this.miId.offsetHeight - 50 + "px";

        function ShowMNow() {
          prxMenuO.miId.style.visibility = "visible";
        }

        this.miTimer = PrxRLsetTimeout(ShowMNow, 150);
      },

      // Hide the menu
      meHide : function() {
        clearTimeout(this.miTimer);
        if (this.miId.style.visibility == "hidden") {
          return;
        }

        function HideMNow() {
          prxMenuO.miId.style.visibility = "hidden";
        }

        this.miTimer = PrxRLsetTimeout(HideMNow, 150);
      },

      // Toggle topographic view: Shows the nesting level of every element
      // using shading. - Jesse Ruderman, Joseph Pearson, sidki
      mlTopo : function() {
        var s = "body", c = "", I = " !important;", i, b, f, x, h;
        if (this.mlTopoS == 1) {
          this.mlTopoS = 0;
          h = document.getElementById("proxTtopo");
          document.getElementsByTagName("head")[0].removeChild(h);
          h = document.styleSheets[0];
        } else {
          if (this.mlTopoS) {
            if (this.mlTopoS.disabled == true) {
              this.mlTopoS.disabled = false;
            } else {
              this.mlTopoS.disabled = true;
            }
          } else {
            for (i = 0; i < 17; ++i) {
              x = i.toString(16);
              b = i > 15 ? "FFCCCC" : x + x + x;
              f = i > 9 ? "000000" : "FFFFFF";
              c += s + " {background: #" + b + I + "border-color: #" + b + I + "color: #" + f + I + "}\n";
              s += " *";
            }
            if (document.createStyleSheet) {
              this.mlTopoS = document.createStyleSheet("javascript:'" + c + "'");
            } else {
              this.mlTopoS = 1;
              h = document.createElement("link");
              h.id = "proxTtopo";
              h.rel = "stylesheet";
              h.href = "data:text/css," + escape(c);
              document.getElementsByTagName("head")[0].appendChild(h);
            }
          }
        }
      },

      // Toggle DOM path: Lists the ancestors of any element you hover over in
      // the status bar. - Jesse Ruderman, sidki
      mlDparent : function() {
        if (this.mlDtoggle) {
          window.defaultStatus = this.mlDtoggle;
          this.mlDtoggle = 0;
          document.onmouseover = PrxDummyZero;
        } else {
          this.mlDtoggle = window.defaultStatus;

          function A(n, g) {
            var p = n.parentNode, t = n.tagName, x, y;
            if (!p) {
              return "";
            }
            for (y = 0, x = n.previousSibling; x; x = x.previousSibling) {
              if (x.nodeName == n.nodeName) {
                y++;
              }
            }
            if (!t) {
              return A(p, g);
            }
            var T = t.toUpperCase(), b = (T != "TABLE" &&
              T != "TBODY" && T != "THEAD" && T != "TR"), c = n.className, i = n.id;
            return A(p, " > ") + (b ? T : T.toLowerCase()) + (y ? "[" + (y + 1) + "]" : "") + (c ? "." + c : "") + (i ? "#" + i : "") + (b ? g : " ");
          }

          function over(e) {
            e = e ? e : event;
            var s, g = e.target;
            g = g ? g : e.srcElement;
            try {
              s = A(g, '');
            } catch(er) {
              s = er.message;
            }
            window.defaultStatus = s + "";
            return true;
          }

          document.onmouseover = over;
          window.defaultStatus = A(document.documentElement, "");
        }
      },

      // Toggle stylesheets. - sidki, Jesse Ruderman
      mlTStyle : function() {
        var i, x = document.styleSheets;
        for (i = 0; i < x.length; i++) {
          if (x[i].disabled) {
            x[i].disabled = 0;
          } else {
            if (!x[i].href.match(/\/local.ptron\//i)) {
              x[i].disabled = 1;
              if (this.meStyle) {
                PrxFooter("style", (x[i].href));
                this.meStyle = "";
              }
            }
          }
        }
      },

      // Show all JavaScript variables and functions. - Jesse Ruderman
      mlJSvars : function() {
        var i, v, st, x = PrxMyPop("", ",width=800,height=600"), d = x.document;
        d.open();

        function hE(s) {
          s = s.replace(/&/g, "&amp;");
          s = s.replace(/>/g, "&gt;");
          s = s.replace(/</g, "&lt;");
          return s;
        }

        var ds = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"\n\"http://www.w3.org/TR/html4/strict.dtd\">";
        ds += "\n<html>\n<head>\n<title>All JS Variables and Functions</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">";
        ds += "\n<style type=\"text/css\">\nbody,td{font:12px/15px Verdana,Arial,sans-serif;color:#313131;background:#CEDFEF;}";
        ds += "\ntd{vertical-align:top;white-space:pre}\ntable,td,th{border:1px solid #91BBE3}\nth.string{text-align:left;padding-left:100px}\ndiv.er{color:red}\n</style>";
        ds += "\n</head>\n<body>\n<table border=1 summary=\"\">\n<thead><tr><th>Variable</th><th>Type</th><th class=string>Value as string</th></tr></thead>\n";
        d.write(ds);
        for (i in window) {
          if (!(i in x)) {
            v = window[i];
            d.write("<tr><td>" + hE(i) + "</td><td>" + hE(typeof (window[i])) + "</td><td>");
            if (v === null) {
              d.write("null");
            } else {
              if (v === undefined) {
                d.write("undefined");
              } else {
                var e1 = "<div class=er>", e2 = "</div>\n";
                try {
                  st = v.toString();
                  if (st.length) {
                    d.write(hE(v.toString()));
                  } else {
                    d.write("\xA0");
                  }
                } catch (er) {
                  d.write(e1 + hE(er.toString()) + e2);
                }
              }
            }
            d.write("</td></tr>\n");
          }
        }
        d.write("</table>\n</body>\n</html>\n");
        d.close();
      },

      // Show all classes and IDs used in the document. - Jesse Ruderman, sidki
      mlIDs : function() {
        var a = {}, aa = {}, b = [], bb = [], i, e, c, k;
        var ds = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"\n\"http://www.w3.org/TR/html4/strict.dtd\">";
        ds += "\n<html>\n<head>\n<title>All Classes and IDs</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">";
        ds += "\n<style type=\"text/css\">\nbody,td{font:12px/15px Verdana,Arial,sans-serif;color:#313131;background:#CEDFEF;}";
        ds += "\ntable,td,th{border:1px solid #91BBE3}\ntable{float:left;margin-right:8px}\n</style>";
        ds += "\n</head>\n<body>\n<table border=1 summary=\"\">\n<thead><tr><th>#</th><th>Tag</th><th>className</th></tr></thead>\n";
        for (i = 0; e = document.getElementsByTagName("*")[i]; ++i) {
          c = e.className;
          if (c) {
            k = e.tagName + "." + c;
            a[k] = a[k] ? a[k] + 1 : 1;
          }
        }
        for (k in a) {
          b.push([k, a[k]]);
        }
        b.sort();
        for (i in b) {
          ds += "<tr><td>" + b[i][1] + "</td><td>" + b[i][0].split(".").join("</td><td>") + "</td></tr>\n";
        }
        ds += "</table>\n";
        ds += "<table border=1 summary=\"\">\n<thead><tr><th>#</th><th>Tag</th><th>ID</th></tr></thead>\n";
        for (i = 0; e = document.getElementsByTagName("*")[i]; ++i) {
          c = e.id;
          if (c) {
            k = e.tagName + "." + c;
            aa[k] = aa[k] ? aa[k] + 1 : 1;
          }
        }
        for (k in aa) {
          bb.push([k, aa[k]]);
        }
        bb.sort();
        for (i in bb) {
          ds += "<tr><td>" + bb[i][1] + "</td><td>" + bb[i][0].split(".").join("</td><td>") + "</td></tr>\n";
        }
        ds += "</table>\n</body>\n</html>\n";
        var d = PrxMyPop("", ",width=500,height=500").document;
        d.write(ds);
        d.close();
      },

      // Show linked and embedded scripts.  Proxomitron's standard scripts are
      // not displayed. - Jesse Ruderman
      mlScripts : function() {
        var d = PrxMyPop("", ",width=800,height=" + screen.height * .7).document;
        d.open();
        var ti = "Scripts in " + location.href;
        var ds = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"\n\"http://www.w3.org/TR/html4/strict.dtd\">";
        ds += "\n<html>\n<head>\n<title>" + ti + "</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">"
        ds += "\n<style type=\"text/css\">\nbody{margin:20px;font:12px/20px Verdana,Arial,sans-serif;color:#313131;background:#CEDFEF;}\nh4{margin:22px 0 6px 0;}\npre{margin:4px 0 4px 0;}\niframe{width:100%;height:27em;border:1px solid;background:#DDEEFE;}\n</style>";
        ds += "\n</head>\n<body>\n<h2>" + ti + "</h2></body>\n</html>";
        d.write(ds);
        d.close();

        function trim(s) {
          return s.replace(/^\s*\n/, "").replace(/\s*$/, "");
        }
        function add(h) {
          d.body.appendChild(h);
        }
        function makeTag(t) {
          return document.createElement(t);
        }
        function makeText(tag, text) {
          var t = makeTag(tag);
          t.appendChild(document.createTextNode(text));
          return t;
        }

        var si, ifr, s = document.getElementsByTagName("script");
        for (var i = 0; i < s.length; ++i) {
          si = s[i];
          if (si.id.indexOf("proxScr") == 0) {
            continue;
          }
          if (si.src) {
            add(makeText("h4", 'script src="' + si.src + '"'));
            ifr = makeTag("iframe");
            ifr.src = si.src;
            add(ifr);
          } else {
            add(makeText("h4", "Inline script"));
            add(makeText("pre", trim(si.innerHTML)));
          }
        }
      },

      // Show DHTML source: Displays the DOM tree of the page as HTML.
      // - Jesse Ruderman
      mlDynSrc : function() {

        function htmlEscape(s) {
          s = s.replace(/&/g, "&amp;");
          s = s.replace(/>/g, "&gt;\n");
          s = s.replace(/</g, "&lt;");
          return s;
        }

        var ds = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"\n\"http://www.w3.org/TR/html4/strict.dtd\">";
        ds += "\n<html>\n<head>\n<title>Dynamic Source</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">"
        ds += "\n<style type=\"text/css\">\nbody,pre{font:12px/20px Verdana,Arial,sans-serif;color:#313131;background:#CEDFEF;}\n</style>";
        ds += "\n</head>\n<body>\n<pre>\n\n" + htmlEscape("<html>" + document.documentElement.innerHTML + "</html>") + "\n</pre>\n</body>\n</html>";
        var d = PrxMyPop("", ",width=800,height=" + screen.height * .6).document;
        d.write(ds);
        d.close();
      },

      // Say what should happen when clicking the menu buttons. - JD, sidki
      mlForm : function(form, what) {
        var all ="", here = window.location, el = form.elements, i, f;
        for (i = 0; i < el.length; i++) {
          f = el[i];
          if (f.checked && f.value != "i_level:" + prxCfgLevel) {
            all += f.value + ".";
          }
        }
        if (what == "go") {
          all = (all) ? "?prx-keyword=." + all : "";
          var query = here.search.match(/^(.*)\?prx-keyword=/);
          query = (!query) ? here.search : query[1];
          here.href = here.protocol + "//" + here.host + here.pathname + query + all + here.hash;
        } else {
          if (what == "list") {
            all = (all) ? all : "YOUR_WORD.";
            var hostR = here.hostname.match(/^https\.\.(.+)/)
            hostR = (hostR) ? hostR[1] :
              ((here.protocol == "https:" && !here.port) ? (here.host + ":443") : here.host);
            here.href = "http://add.to.proxlist/" + hostR +
              here.pathname.match(/^\/([^\/]+\/)*/g) +
              "$$$SET(keyword=$GET(keyword)" + all + ")$$" + here.href;
          } else {
            if (what == "session") {
              here.href = "http://add.to.memlist/" +
                "$SET(a=" + all + ")PrxFail$TST()$$" + here.href;
            }
          }
        }
      },

      // Initialize the constant icon position upon first mouse click.
      miTimer : "", // Avoid strict warning.

      miInit : function(e) {
        var tag = (e.target) ? e.target : e.srcElement;
        if (tag.tagName == "A") {
          return;
        }

        this.miTimer = 0;
        var naomi = (prxDAll) ?
          document.all.proxMIcon : document.getElementById("proxMIcon");
        var nasty = (naomi) ? naomi.style : null;
        if (!nasty) {
          PrxFooter("Uh Oh", "Something's fishy!");
          return;
        }

        function miHide() {
          if (nasty.visibility == "visible") {
            PrxRLsetTimeout(function() {nasty.visibility = "hidden";}, 150);
          }
        }

        function miShow() {
          if (prxLdTimer) {
            status = window.defaultStatus = prxTgO.tgTop.prxLdStop;
          }
          if (nasty.visibility == "visible") {
            return;
          }
          var bodyX = (prxIsMoz) ?
            (prxElement.clientWidth - document.body.clientWidth) / 2 :
            document.body.offsetLeft;
          nasty.left =
            ((window.pageXOffset) ? window.pageXOffset : prxElement.scrollLeft) +
            prxElement.clientWidth - bodyX - 50 + "px";
          nasty.top =
            ((window.pageYOffset) ? window.pageYOffset : prxElement.scrollTop) +
            prxElement.clientHeight - 50 + "px";
          nasty.visibility = "visible";
        }

        if (prxIsMoz) {
          PrxEventRemove(window, "click", prxMenuO.miInit);
          PrxEventAdd(window, "click", miShow);
          PrxEventAdd(window, "DOMMouseScroll", miHide);
        } else {
          PrxEventRemove(document, "click", prxMenuO.miInit);
          PrxEventAdd(document, "click", miShow);
        }
        PrxEventAdd(window, "resize", miHide);
        PrxEventAdd(window, "scroll", miHide);
        miShow();

        if (prxCfgLevel < 5) {
          delete prxMenuO.miInit;
        }

        prxMenuO.miId = (prxDAll) ?
          document.all.proxMDiv : document.getElementById("proxMDiv");
        prxMenuO.miX = prxMenuO.miId.offsetWidth;
      }
    }

  }

  /* ====================================
     Last chance to write to the page - sidki
     ==================================== */

  var prxCatchLocURL, prxCatchEvents, prxStyleSel;

  // Declare the style selector. - Tantek Celik
  function PrxStyleSwitch() {
    var sheets = ",", options = "<option selected>document default</option>";
    for (var i = 0, d = document.styleSheets; i < d.length; i++) {
      var s = d[i];
      var tt = s.title;
      if (tt != "" && tt != undefined) {
        if (sheets.indexOf("," + tt + ",") == -1) {
          sheets += tt + ",";
          options += "<option>" + tt + "</option>";
        }
      }
    }
    var ds = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"\n\"http://www.w3.org/TR/html4/strict.dtd\">";
    ds += "\n<html><head><title>Select Stylesheet</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">";
    ds += "\n<style type=\"text/css\">\nbody{margin:0;font:12px/20px Verdana,Arial,sans-serif;background:#CEDFEF;}";
    ds += "\ndiv{margin:0;padding:15px 10px 15px 10px}\nselect{width:170px;background:#A5CFF7;}\n</style>";
    ds += "\n<script type=\"text/javascript\">\nfunction choosess(tt){var x=window.opener.document;";
    ds += "for(var i=0,d=x.styleSheets;i<d.length;i++){var s=d[i];var ti=s.title;if(ti!=\"\" && ti!=undefined && ti!=tt)s.disabled=true;else s.disabled=false;}}\n</script>";
    ds += "\n</head>\n<body>\n<div>";
    ds += "\n<select id=\"st\" size=5 onkeypress=\"var k=event.keyCode;if(k==13 || k==3 || k==27){window.close()}\"";
    ds += " onchange=\"if(this.selectedIndex!=-1)choosess(this.options[this.selectedIndex].text);\">" + options + "</select>";
    ds += "\n</div>\n</body></html>";
    var dw = PrxMyPop("", ",width=193,height=119").document;
    dw.write(ds);
    dw.close();
    dw.getElementById("st").focus();
  }

  prxIntO.iWrite = function(tag, onload) {
    var wr = "";

    // Clickable flyover  Part II. - Dynamic Drive, sidki, Martin Konicek
    var wf = "<div id=\"proxFlyover\" onmouseover=\"prxFlyO.flClearHide();\" onmouseout=\"prxFlyO.flDynHide(event);\"></div>\n";

    // See if the style selector should be invoked - IE and Mozilla only.
    // - sidki
    if (prxStyleSel && (prxIsMoz || prxIsIE)) {
      for (var i = 0, d = document.styleSheets; i < d.length; i++) {
        var s = d[i], tt = s.title, st;
        if (tt != "" && tt != undefined) {
          st = 1;
        }
      }
      if (st) {
        wr += "<span class=\"ProxBotLinkJs Prox\" style=\"display:inline\">" +
          "&#8593;<a class=\"ProxBotLinkJs Prox\"" +
          " href=\"javascript:PrxStyleSwitch()\">styles</a></span>\n";
      }
    }

    // Intercept calls to *.location.replace() Part II. - Paul Rupe, sidki
    if (prxCatchLocURL) {
      wr += "<span class=\"ProxRedir Prox\" style=\"display:inline\">" +
        "&#8593;<a class=\"ProxRedir Prox\" href=\"" + prxCatchLocURL +
        " \" target=_top>tame redirect</a></span>\n";
    }

    // Write it - Create DIV Block if not already done so.
    if (wr) {
      if (!tag) {
        wr = "<div id=\"proxDivJs\">\n" + wr;
        wr += "</div>\n";
      }
    }
    document.write(wf + wr);

    // Create a button if specific onload events were found. - sidki
    if (onload) {
      prxButtonO.getOnload();
    }
    if (prxCatchEvents) {
      prxButtonO.getEvents();
      prxButtonO.getOnerror();
    }

    // Write the hidden timer button.  "onmouseover" and "oncontextmenu" just
    // deal with the first timer instance.  "onclick" launches all instances.
    // If any timers were already intercepted, show the button. - sidki
    document.writeln("<input id=\"proxTimer\" class=\"ProxButton\" " +
      "style=\"display:none\" type=\"button\" value=\"timer\" " +
      "onmouseover=\"prxFlyO.flShow('<div class=ProxFlyCont>' + prxTimerO.tiFirst.over + '</div>',event,0)\" " +
      "onmouseout=\"prxFlyO.flDHide()\" onclick=\"prxTimerO.tiClick()\" " +
      "oncontextmenu=\"PrxRLsetTimeout(prxTimerO.tiFirst.rclick, 10); return false;\">");
    if (prxTimerO && prxTimerO.tiColl) {
      document.getElementById("proxTimer").style.display = "inline";
    }

    // We've reached the end of the page.
    prxLoaded = 1;
  }

  /* ====================================
     Run this function at the very last. - ...
     ==================================== */

  var prxTgForm;

  prxIntO.iFinal = function() {

    // If our environment is gone, return (XMLHttpRequest/AJAX).
    if (typeof prxLoaded == "undefined") {
      return;
    }

    // Page Load Timer Part II. - hpguru
    if (prxLdTimer) {
      var tsplit = (prxCfgLevel > 3) ?
        ((new Date()).getTime() - prxLdStart.getTime()) / 1000 + " -> " : "";
    }

    // In case we want to do something specific with child frames, check if
    // this is one.  If true, get the current domain. - sidki
    if (prxTgFrame) {
      var url = this.location.href, s = url.indexOf("://");
      s = (s > -1 && s < 6) ? url.substr(s + 3) : 0;
      if (s) {
        try {
          prxTgFrame = (top.location.href != url) ? PrxGetDomain(s) : 0;
        } catch (er) {
          prxTgFrame = PrxGetDomain(s);
        }
      } else {
        prxTgFrame = 0;
      }
    }

    // Get Window Names Part III. - Mike/z12
    prxTgO.tgInit();

    // Open form targets that refer to non-existing windows in the top window.
    // - Paul Rupe
    var i, d, f, t;
    if (prxTgForm) {
      for (i = 0, d = document.forms; i < d.length; i++) {
        f = d[i], t = f.target;
        if (t && typeof t == "string" && !prxTgO.tgCheck(t)) {
          f.target = "_top";
        }
      }
    }

    // Set some of an object's event handlers to null - Part II. - Paul Rupe
    if (prxStopEvents) {
      PrxClearEvent(document);
      PrxClearEvent(document.body);
      PrxClearEvent(window);
    }

    // Proxomitron Menu  Part II. - sidki
    if (prxMenu) {
      if (prxIsMoz) {
        PrxEventAdd(window, "click", prxMenuO.miInit);
      } else {
        PrxEventAdd(document, "click", prxMenuO.miInit);
      }
      if (prxCfgLevel < 5) {
        delete prxMenuO.meWrite;
      }
    }

    // Delete object properties that aren't needed anymore.
    if (prxCfgLevel < 5) {
      delete prxButtonO.create;
      delete prxButtonO.getEvents;
      delete prxButtonO.getOnload;
      delete prxButtonO.getOnerror;
      delete prxIntO.iGetEl;
      delete prxIntO.iWrite;
    }

    // Anti-Popup Code Part II. - Scott R. Lemmon
    if (prxPopup) {
      PrxEventAdd(
        document, "mouseup",
        function() {prxPopClick = prxTgO.tgTop.prxPopClick = new Date()}
      );
    }

    // Page Load Timer Part III. - hpguru
    if (prxLdTimer) {
      prxLdStop = "Load Time (sec): " +
        tsplit + ((new Date()).getTime() - prxLdStart.getTime()) / 1000;
      status = window.defaultStatus = prxLdStop;
    }

    // All done.
    prxLoaded = 2;
    if (prxCfgLevel < 5) {
      delete prxIntO.iFinal;
    }

    // And then some.
    PrxRLsetTimeout("prxLoaded = 3", 1);

  }

}
