/*****************************************************************************
 *
 * External script for sidki's Proxomitron config
 *
 * This is the stripped-down version, used in "minimal config mode", and with
 * Netscape 4.x.
 *
 * Last edited: 2005-10-12
 *
 *****************************************************************************/

// Parse the whole shebang only if not already done so (XMLHttpRequest/AJAX).
var prxDoneTop;
prxDoneTop = (typeof prxDoneTop == "undefined") ? 0 : prxDoneTop + 1;
if (!prxDoneTop) {

  /******************************* PAGE START ********************************/

  /* ====================================
     Set some flags.
     ==================================== */

  // Current config mode, set by Proxomitron filters:
  // 1 -> minimal, 2 -> light, 3 -> standard, 4 -> advanced, 5 -> debug.
  var prxCfgLevel;

  // This flag indicates where we currently are in our script. Four stages:
  // 0 -> Beginning.
  // 1 -> End of page.
  // 2 -> Onload event has fired.
  // 3 -> Tiny delay, as IE may run the page's onload function after our one.
  var prxLoaded = 0;

  // Declare the flag that counts replacements of ad scripts with dummy.js.
  var prxDummy = 0;

  // Test for "document.all" support.
  var prxDAll = (document.all) ? 1 : 0;

  // Detect IE, Mozilla, and Opera. - hpguru
  var prxIsIE = (prxDAll && document.getElementById && !window.opera) ? 1 : 0;
  var prxIsMoz = (!prxDAll && document.getElementById && !window.opera) ? 1 : 0;
  var prxIsOp = (window.opera) ? 1 : 0;
  var prxIsNN = (document.layers) ? 1 : 0;

  /* ====================================
     Cross-browser event listener registration - Mozilla/IE/Opera/NN4.
     - Scott Andrew LePera
     ==================================== */

  // Temporary handles for the W3C and IE event registration methods.
  window.PrxTMPaddEventListener = window.addEventListener;
  var PrxTMPattachEvent = window.attachEvent;

  function PrxEventAdd(obj, evn, fn, cap) {
    if (!prxIsIE && obj.addEventListener) {
      if (window.PrxTMPaddEventListener) {
        window.addEventListener = window.PrxTMPaddEventListener;
        delete window.PrxTMPaddEventListener;
      }
      cap = (cap) ? cap : false;
      obj.addEventListener(evn, fn, cap);
      // alert("addEvent: " + obj + " :: " + evn);
    } else {
      if (obj.attachEvent) {
        if (PrxTMPattachEvent) {
          window.attachEvent = PrxTMPattachEvent;
          PrxTMPattachEvent = "";
        }
        obj.attachEvent("on" + evn, fn);
        // alert("attachEvent: " + obj + " :: " + evn);
      } else {
        obj["on" + evn] = fn;
        // alert("addNN4: " + obj + " :: " + evn);
      }
    }
  }

  /* ====================================
     Set some of an object's event handlers to null - Part I. - Paul Rupe
     ==================================== */

  var prxStopEvents;
  if (prxStopEvents) {

    function PrxClearEvent(a) {
      if (!a) {
        return;
      }
      a.onmouseleave = null;
      a.onmouseout = null;
      a.onmousewheel = null;
      a.onbeforeunload = null;
      a.onunload = null;
      a.onbeforeprint = null;
      a.onafterprint = null;
      a.onblur = null;
      a.onfocus = null;
      a.onfocusout = null;
      a.onkeydown = null;
      a.onkeypress = null;
      a.onkeyup = null;
      a.oncontextmenu = null;
      a.ondeactivate = null;
      a.onhelp = null;
      a.onlosecapture = null;
      a.onpropertychange = null;
      a.onresize = null;
      a.onscroll = null;
      a.onselect = null;
      a.onselectstart = null;
    }
  }

  /* ====================================
     Anti-Popup Code Part I. - Scott R. Lemmon
     ==================================== */

  var prxPopup;
  if (prxPopup) {
    var prxPopClick = new Date(0);
    if (prxIsMoz) {
      Window.prototype.PrxRLopen = Window.prototype.open;
    } else {
      eval("var PrxRLopen = window.open");
    }

    // To reroute showModalDialog/showModelessDialog, the second parameter MUST
    // be tested/converted to string if need be since dialogs can also accept
    // objects, whereas "open" only accepts strings as second parameter.
    // A further problem can arise in the third parameter.  The dialog calls
    // have a slightly different format.  Size for instance is passed
    // differently and uses a semicolon instead of an equal sign. - TEggHead
    function PrxNWopen(url, enam, atr) {

      // Add this line to make sure the second param is a string. - TEggHead
      var nam = (typeof enam == "object") ? "Dialog" :
        (enam == null) ? "Blank" : enam;

      // Allow windows referring to trusted target names - Paul Rupe
      if (nam && nam.indexOf("prx_") == 0) {
        return (PrxRLopen(url, nam, atr));
      }

      // If the page has already loaded and the mouse was clicked within 2
      // seconds, then allow the window.
      var cdt = new Date();
      cdt.setTime(cdt.getTime() - prxPopClick.getTime());
      if (prxPopup == 2 || prxLoaded > 1 && cdt.getSeconds() < 2) {
        if (atr) {
          var query = (url.match(/^(about|keyword):|\?/gi)) ? "" :
            "?prx-keyword=.i_popup_b:11.";
          return (PrxRLopen(url + query, nam, PrxPopAtrSet(atr)));
        } else {
          return (PrxRLopen(url, nam));
        }
      }
    }

    var prxPopAtr;

    function PrxPopAtrSet(atr) {
      if (!prxPopAtr) {
        return (atr);
      }
      var yatr = (prxPopAtr == 2) ? 1 : 0;
      var xatr = "location=1,status=1,scrollbars=1,resizable=1";
      xatr += ",left=" + screen.width * .01 + ",top=" + screen.height * .12;
      xatr += "toolbar=" + yatr + ",menubar=" + yatr;
      if (atr) {
        var hm;
        hm = atr.match(/height(=|:)([0-9]+)/i);
        if (hm) {
          xatr += ",height=" + hm[2];
        } else {
          xatr += ",height=480";
        }
        hm = atr.match(/width(=|:)([0-9]+)/i);
        if (hm) {
          xatr += ",width=" + hm[2];
        } else {
          xatr += ",width=640";
        }
      } else {
        xatr += ",height=480,width=640";
      }
      return (xatr);
    }

    window.open = PrxNWopen;

    // IE Specific Methods. - Homeric
    window.showModalDialog = PrxNWopen;
    window.showModelessDialog = PrxNWopen;
  }

  /* ====================================
     Strip Proxomitron URL commands from the "hostname" and "href" properties.
     Set "protocol" to "https:", if the URL command was "https..".  Since the
     "location" object cannot be manipulated in IE without leaving the page,
     we need to attach two new properties and rename the original strings
     with a webfilter. - sidki
     ==================================== */

  function PrxFixLoc() {
    var a = location, b = a.hostname, c = b.indexOf(".."), d = a.href, e = d.indexOf("..");
    a.PRXprotocol = (b.indexOf("https..") != -1) ? "https:" : a.protocol;
    a.PRXhostname = (c != -1)? b.substr(c + 2) : b;
    a.PRXhref = (c != -1 && e != -1)? a.PRXprotocol + "//" + d.substr(e + 2) : d;
  }
  PrxFixLoc()

  /* ====================================
     Define the properties as renamed by the "Block: Sel. JS Properties"
     filters. - sidki
     ==================================== */

  var prxSyncUA;
  if (prxSyncUA) {
    if (navigator.PRXuserAgent) {
      navigator.PRXappVersion = navigator.PRXuserAgent.match(/\d[^)]+\)/).toString();
      navigator.PRXappMinorVersion = navigator.PRXappVersion;
      if (navigator.PRXuserAgent.indexOf("Mozilla/4.0") == 0) {
        navigator.PRXappName = "Microsoft Internet Explorer";
      } else {
        if (navigator.PRXuserAgent.indexOf("Mozilla/") == 0) {
          navigator.PRXappName = "Netscape";
        } else {
          if (navigator.PRXuserAgent.indexOf("Opera/") == 0) {
            navigator.PRXappName = "Opera";
          } else {
            navigator.PRXappName = "";
          }
        }
      }
    }
    navigator.PRXcpuClass = "alpha";
    navigator.PRXuserLanguage = "en";
    navigator.PRXbrowserLanguage = "en";
    navigator.PRXsystemLanguage = "en";
    navigator.PRXjavaEnabled = true;
    navigator.PRXcookieEnabled = true;
  }

  /* ====================================
     Block various Methods. - Paul Rupe, sidki
     ==================================== */

  // Called by Proxomitron instead of the real names.
  if (prxIsMoz) {
    Window.prototype.PrxRLsetTimeout = Window.prototype.setTimeout;
    Window.prototype.PrxRLsetInterval = Window.prototype.setInterval;
  } else {
    eval("var PrxRLsetTimeout = window.setTimeout");
    eval("var PrxRLsetInterval = window.setInterval");
  }

  // Dummy function.
  function PrxDummyZero(string) {
  }

  var prxStopMethods;
  if (prxStopMethods) {

    // Override some window manipulation APIs (which never should have existed
    // in first place).
    window.focus = PrxDummyZero;
    window.resizeBy = PrxDummyZero;
    window.moveBy = PrxDummyZero;

    function clipboardData() {
      return true;
    }

    function createPopup() {
      return true;
    }

    // Override these window properties as well.
    function status() {
      return true;
    }
  }

  /* ====================================
     Provide definitions for properties or common functions that get renamed or
     filtered out and cause subsequent errors. - Paul Rupe, sidki
     ==================================== */

  var prxVoid, MSIE, expires = new Date(0);
  document.PRXcookie = "ProxMessage=GoFigureItOut";

  // Block ad blocker detection in http://spywareguide.com/abd.js and possibly
  // elsewhere.
  var google_random = 1;

  // Would at least break things at FOXNews if undefined.
  function OAS_AD() {
    return true;
  }

  /* ====================================
     Restrict Message Boxes. - Paul Rupe
     ==================================== */

  var prxCatchBoxes;
  if (prxCatchBoxes) {
    if (prxIsMoz) {
      Window.prototype.PrxRLprompt = Window.prototype.prompt;
      Window.prototype.PrxRLconfirm = Window.prototype.confirm;
    } else {
      eval("var PrxRLprompt = window.prompt");
      eval("var PrxRLconfirm = window.confirm");
    }

    // Returns true if alert/confirm/prompt have not been called a bunch of
    // times already, false if they have not.  Used to stop runaway scripts
    // abusing these popup functions.
    function PrxCatchBoxCheck() {
      if (prxLoaded < 2 || prxCatchBoxes == 999) {
        return false;
      }
      if (--prxCatchBoxes >= 0) {
        return true;
      }
      if (PrxRLconfirm("*** PROXOMITRON ALERT ***\nThis script is too busy for its own good.  Kill it?")) {
        prxCatchBoxes = 999;
        return false;
      } else {
        return true;
      }
    }

    function PrxNWconfirm(m) {
      if (!PrxCatchBoxCheck()) {
        return null;
      }
      return PrxRLconfirm(m);
    }
    window.confirm = PrxNWconfirm;

    function PrxNWprompt(m, d) {
      if (!PrxCatchBoxCheck()) {
        return null;
      }
      if (!d) {
        d = "";
      }
      return PrxRLprompt(m, d);
    }
    window.prompt = PrxNWprompt;

    function PrxNW2alert(m) {
      if (!PrxCatchBoxCheck()) {
        return null;
      }
      return PrxRLalert(m);
    }
    window.alert = PrxNW2alert;
  }

  /* ====================================
     Toggle (show/hide) span tags with specified classname or ID. - sidki
     ==================================== */

  function PrxToggle(nam, atr, tag, tog) {
    var tags = window.document.getElementsByTagName(tag);
    for (var i = 0; i < tags.length; i++) {
      if ((atr == "cl" && nam == tags[i].className.split(" ")[0]) ||
        (atr == "id" && nam == tags[i].id)) {
        if (tags[i].style.display != "inline") {
          tags[i].style.display = "inline";
        } else {
          if (tog) {
            tags[i].style.display = "none";
          }
        }
        if (tags[i].style.visibility == "hidden") {
          tags[i].style.visibility = "visible";
        } else {
          if (tags[i].style.visibility == "visible") {
            tags[i].style.visibility = "hidden";
          }
        }
      }
    }
  }

  /* ====================================
     Clickable flyover  Part I. - Dynamic Drive, sidki, Martin Konicek
     ==================================== */

  // This minimal script just declares dummy functions.
  var prxFlyO = {
    flShow : function() {},
    flDHide : function() {},
    flLink : function() {}
  }

  /******************************** PAGE END *********************************/

  /* ====================================
     The object that deals with internal functions.
     ==================================== */

  var prxIntO = new Object();

  /* ====================================
     Set the main target element depending on rendering mode and browser.
     Needs to be called when the page is already loaded. - sidki
     ==================================== */

  // This minimal script just declares a dummy function.
  prxIntO.iGetEl = function() {}

  /* ====================================
     Last chance to write to the page - sidki
     ==================================== */

  prxIntO.iWrite = function(tag, onload) {

    // We've reached the end of the page.
    prxLoaded = 1;
  }

  /* ====================================
     Run this function at the very last. - ...
     ==================================== */

  prxIntO.iFinal = function() {

    // If our environment is gone, return (XMLHttpRequest/AJAX).
    if (typeof prxLoaded == "undefined") {
      return;
    }

    // Set some of an object's event handlers to null - Part II. - Paul Rupe
    if (prxStopEvents) {
      PrxClearEvent(document);
      PrxClearEvent(document.body);
      PrxClearEvent(window);
    }

    // Anti-Popup Code Part II. - Scott R. Lemmon
    if (prxPopup) {
      PrxEventAdd(
        document, "mouseup",
        function() {prxPopClick = new Date()}
      );
    }

    // All done.
    prxLoaded = 2;

    // And then some.
    PrxRLsetTimeout("prxLoaded = 3", 1);

  }

}
